// GadgetScrew.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <stdio.h>
#include <shlobj.h>
#include <shlwapi.h>
#include <shellapi.h>
#include <string>
#include <vector>
#include "GadgetScrew.h"
#include "misc.h"

#define KEYNAME_GADGET	_T("PrivateSetting_GadgetName")
#define KEYNAME_XPOS	_T("PrivateSetting_GadgetDropLocationX")
#define KEYNAME_YPOS	_T("PrivateSetting_GadgetDropLocationY")

typedef std::basic_string<TCHAR> tstring;

typedef struct _SETTING_LIST
{
	int num;
	tstring name;
	long x,y;
	bool ref;
} SETTING_LIST;

void CheckIni( TCHAR *org, TCHAR *bak, BOOL force )
{
	TCHAR strSec[32];
	TCHAR temp[_MAX_PATH];
	int nEntryOrg, nSec, nPosX, nPosY, nShift, scanfRet;

	std::vector<SETTING_LIST> v_list;
	std::vector<SETTING_LIST>::iterator Iter;
	SETTING_LIST item;
	bool found;

	// ݒ̓ǂݏo
	for ( nSec = 0;; ) {
		// [Root]̃ZNVL[
		_stprintf_s( strSec, 32, _T("Section%d"), nSec++ );

		// IWiZNVo
		GetPrivateProfileString( _T("Root"), strSec, NULL, temp, _MAX_PATH, bak );
		if ( temp[0] == 0 ) {
			break;
		}
		_stscanf_s( temp, _T("%d"), &nEntryOrg );

		// ZNV
		_stprintf_s( strSec, 32, _T("Section %d"), nEntryOrg );

		// ݒo
		GetPrivateProfileString( strSec, KEYNAME_XPOS, NULL, temp, _MAX_PATH, bak );
		_stscanf_s( temp, _T("%d"), &nPosX );
		GetPrivateProfileString( strSec, KEYNAME_YPOS, NULL, temp, _MAX_PATH, bak );
		_stscanf_s( temp, _T("%d"), &nPosY );
		GetPrivateProfileString( strSec, KEYNAME_GADGET, NULL, temp, _MAX_PATH, bak );

		// vectorɕۑ
		item.num = nEntryOrg;
		item.name = temp;
		item.x = nPosX;
		item.y = nPosY;
		item.ref = false;
		v_list.push_back( item );
	}

	// eڂ̊mFƃoOړo
	for ( nSec = 0;; ) {
		// [Root]̃ZNVL[
		_stprintf_s( strSec, 32, _T("Section%d"), nSec++ );

		// IWiZNVo
		GetPrivateProfileString( _T("Root"), strSec, NULL, temp, _MAX_PATH, org );
		if ( temp[0] == 0 ) {
			break;
		}
		_stscanf_s( temp, _T("%d"), &nEntryOrg );

		// ZNV
		_stprintf_s( strSec, 32, _T("Section %d"), nEntryOrg );

		GetPrivateProfileString( strSec, KEYNAME_XPOS, NULL, temp, _MAX_PATH, org );
		_stscanf_s( temp, _T("%d"), &nPosX );
		GetPrivateProfileString( strSec, KEYNAME_YPOS, NULL, temp, _MAX_PATH, org );
		_stscanf_s( temp, _T("%d"), &nPosY );
		GetPrivateProfileString( strSec, KEYNAME_GADGET, NULL, temp, _MAX_PATH, org );

		for ( Iter = v_list.begin(), found = false; Iter != v_list.end(); Iter++ ) {
			if ( ( (*Iter).num == nEntryOrg ) && ( (*Iter).name == temp ) ) {
				(*Iter).ref = true;
				nShift = (*Iter).x - nPosX;
				// oOړH
				if ( force || ( ( nShift == 6 ) || ( nShift == 12 ) ) ) {
					_stprintf_s( temp, _MAX_PATH, _T("\x22%d\x22"), (*Iter).x );
					WritePrivateProfileString( strSec, KEYNAME_XPOS, temp, org );
				}
				// Ӑ}IړȂ̂Settings.iniD
				else {
					(*Iter).x = nPosX;
				}
				// Y͊{ISettings.iniD
				if ( force ) {
					_stprintf_s( temp, _MAX_PATH, _T("\x22%d\x22"), (*Iter).y );
					WritePrivateProfileString( strSec, KEYNAME_YPOS, temp, org );
				}
				else {
					(*Iter).y = nPosY;
				}
				found = true;
				break;
			}
		}
		// ǉ̑Ή
		if ( !found ) {
			// ւ`FbN
			for ( Iter = v_list.begin(), found = false; Iter != v_list.end(); Iter++ ) {
				if ( (*Iter).num == nEntryOrg ) {
					v_list.erase( Iter );
					break;
				}
			}
			// vectorɒǉ
			item.num = nEntryOrg;
			item.name = temp;
			item.x = nPosX;
			item.y = nPosY;
			item.ref = true;
			v_list.push_back( item );
		}
	}

	// ݒ̕ۑ (̎ZNVԍɑ΂)
	for ( Iter = v_list.begin(), found = false; Iter != v_list.end(); Iter++ ) {
		_stprintf_s( strSec, 32, _T("Section %d"), (*Iter).num );
		if ( (*Iter).ref ) {
			found = false;
			if ( ( GetPrivateProfileString( strSec, KEYNAME_GADGET, NULL, temp, _MAX_PATH, bak ) == 0 ) || ( (*Iter).name != temp ) ) {
				tstring ntemp = _T("\x22");
				ntemp += (*Iter).name;
				ntemp += _T("\x22");
				WritePrivateProfileString( strSec, KEYNAME_GADGET, ntemp.c_str(), bak );
				found = true;
			}
			GetPrivateProfileString( strSec, KEYNAME_XPOS, NULL, temp, _MAX_PATH, bak );
			scanfRet = _stscanf_s( temp, _T("%d"), &nPosX );
			if ( ( scanfRet == 0 ) || ( scanfRet == EOF ) || ( (*Iter).x != nPosX ) ) {
				_stprintf_s( temp, _MAX_PATH, _T("\x22%d\x22"), (*Iter).x );
				WritePrivateProfileString( strSec, KEYNAME_XPOS, temp, bak );
				found = true;
			}
			GetPrivateProfileString( strSec, KEYNAME_YPOS, NULL, temp, _MAX_PATH, bak );
			scanfRet = _stscanf_s( temp, _T("%d"), &nPosY );
			if ( ( scanfRet == 0 ) || ( scanfRet == EOF ) || ( (*Iter).y != nPosY ) ) {
				_stprintf_s( temp, _MAX_PATH, _T("\x22%d\x22"), (*Iter).y );
				WritePrivateProfileString( strSec, KEYNAME_YPOS, temp, bak );
				found = true;
			}
			// [Root]̍XV
			if ( found ) {
				for ( nSec = 0;; ) {
					_stprintf_s( strSec, 32, _T("Section%d"), nSec++ );
					GetPrivateProfileString( _T("Root"), strSec, NULL, temp, _MAX_PATH, org );
					_stscanf_s( temp, _T("%d"), &nEntryOrg );
					if ( temp[0] == 0 ) {
						break;
					}
					else if ( (*Iter).num == nEntryOrg ) {
						_stprintf_s( temp, _MAX_PATH, _T("\x22%d\x22"), nEntryOrg );
						WritePrivateProfileString( _T("Root"), strSec, temp, bak );
					}
				}
			}
		}
		// 폜ꂽKWFbg̑Ή
		else {
			// [Setcion n]̍폜
			WritePrivateProfileString( strSec, NULL, NULL, bak );
			// [Root]Section폜
			for ( nSec = 0;; ) {
				_stprintf_s( strSec, 32, _T("Section%d"), nSec++ );
				GetPrivateProfileString( _T("Root"), strSec, NULL, temp, _MAX_PATH, bak );
				_stscanf_s( temp, _T("%d"), &nEntryOrg );
				if ( temp[0] == 0 ) {
					break;
				}
				else if ( (*Iter).num == nEntryOrg ) {
					WritePrivateProfileString( _T("Root"), strSec, NULL, bak );
				}
			}
		}
	}
}


void MakeProfilePath( TCHAR *org, TCHAR *bak, int len )
{
	TCHAR szOrg[_MAX_PATH], szBak[_MAX_PATH];
	TCHAR path[_MAX_PATH], drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];

	// IWĩpX𐶐
	SHGetSpecialFolderPath( NULL, szOrg, CSIDL_LOCAL_APPDATA, 0 );
	_tcscat_s( szOrg, _T("\\Microsoft\\Windows Sidebar\\Settings.ini") );

	// obNAbṽpX𐶐
	GetModuleFileName( NULL, path, _MAX_PATH );
	_tsplitpath_s( path, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, ext, _MAX_EXT );
	GetCurrentDirectory( _MAX_PATH, szBak );
	_tcscat_s( szBak, _MAX_PATH, _T("\\") );
	_tcscat_s( szBak, _MAX_PATH, fname );
	_tcscat_s( szBak, _MAX_PATH, _T(".ini") );

	_tcscpy_s( org, len, szOrg );
	_tcscpy_s( bak, len, szBak );
}


void LaunchSidebar(void)
{
	TCHAR szProgram[_MAX_PATH];
	SHELLEXECUTEINFO	sei;

	EnableWow64Redirect( FALSE );
	SHGetSpecialFolderPath( NULL, szProgram, CSIDL_PROGRAM_FILES, 0 );
	_tcscat_s( szProgram, _MAX_PATH, _T("\\Windows Sidebar\\sidebar.exe") );
	memset( &sei, 0, sizeof( sei ) );
	sei.cbSize = sizeof( sei );
	sei.hwnd = NULL;
	sei.nShow = SW_NORMAL;
	sei.lpFile = szProgram;
	ShellExecuteEx( &sei );
	EnableWow64Redirect( TRUE );
}


int APIENTRY _tWinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPTSTR    lpCmdLine,
					 int	   nCmdShow)
{
	TCHAR szOrg[_MAX_PATH], szBak[_MAX_PATH];
	BOOL force = FALSE;

	int argc;
	LPWSTR *argv = CommandLineToArgvW( GetCommandLineW(), &argc );

	if ( argc > 1 ) {
		if ( argv[1][0] == L'/' ) {
			if ( ( argv[1][1] == L'f' ) || ( argv[1][1] == L'F' ) ) {
				force = TRUE;
			}
		}
	}

	// ݒt@C̃pX
	MakeProfilePath( szOrg, szBak, _MAX_PATH );

	// ύXmF
	CheckIni( szOrg, szBak, force );

	// TCho[N
	LaunchSidebar();

	return 0;
}
